/* engine/pki_pkey.c */

#ifndef _LIBPKI_ENGINE_PKEY_H
#define _LIBPKI_ENGINE_PKEY_H

PKI_KEYPAIR *HSM_ENGINE_KEYPAIR_new( int type, int bits, 
				char *label, PKI_CRED *cred, void *driver );

/* Key Free function */
int HSM_ENGINE_KEYPAIR_free ( PKI_KEYPAIR *pkey, void *driver );

/* Key Pair removal function */
int HSM_ENGINE_KEYPAIR_remove ( PKI_KEYPAIR *key, char *label, void *driver );

/*
int PKI_ENGINE_KEYPAIR_write_file( PKI_KEYPAIR *key, char * label, 
				int format, char *file, void *driver );
*/

/* Load a Key from an ENGINE */
PKI_KEYPAIR * HSM_ENGINE_KEYPAIR_get_url ( URL *url,
						PKI_CRED *cred, void *driver );

/* Export a Key */
int HSM_ENGINE_KEYPAIR_export_url( PKI_KEYPAIR *key, char * label, int format,
			URL *url, PKI_CRED *cred, void *driver );
#endif
