/* ENGINE Object Management Functions */

#ifndef _LIBPKI_HEADERS_OPENSSL_PKEY_H
#define _LIBPKI_HEADERS_OPENSSL_PKEY_H

int HSM_OPENSSL_KEYPAIR_free ( PKI_KEYPAIR *pkey, void *driver );
int HSM_OPENSSL_KEYPAIR_remove ( PKI_KEYPAIR *key, char *label, void *driver );

int PKI_OPENSSL_KEYPAIR_write_file( PKI_KEYPAIR *key, char *label, int format, 
						char *file, void *driver );

/* Generate a new Key */
PKI_KEYPAIR *HSM_OPENSSL_KEYPAIR_new( int type, int bits, 
				char *label, PKI_CRED *cred, void *driver );

/* Load a Key */
PKI_KEYPAIR * HSM_OPENSSL_KEYPAIR_get_url ( URL *url, PKI_CRED *cred, 
								void *driver );
/* Export Key */
int HSM_OPENSSL_KEYPAIR_export_url( PKI_KEYPAIR *key, char *label, 
				int format, URL *url_s, PKI_CRED *cred, 
							void *driver );
int PKI_OPENSSL_KEYPAIR_export_file( PKI_KEYPAIR *key, int format, URL *url,
						PKI_CRED *cred );

#endif

