/* libpki KEYPAIR I/O */

#ifndef _LIBPKI_KEYPAIR_IO_HEADER_H
#define _LIBPKI_KEYPAIR_IO_HEADER_H

/* Load a PKI_KEYPAIR from a provided URL string */
PKI_KEYPAIR *PKI_KEYPAIR_get ( char *url_s, PKI_CRED *pwd, HSM *driver );
PKI_KEYPAIR *PKI_KEYPAIR_get_url ( URL *url, PKI_CRED *pwd, HSM *driver );

/* Write a PKI_KEYPAIR object to a file */
int PKI_KEYPAIR_write( PKI_KEYPAIR *key, int format, char *url_s, HSM *hsm );
int PKI_KEYPAIR_write_url( PKI_KEYPAIR *key, int format, URL *url, HSM *hsm );
int PKI_KEYPAIR_write_file( PKI_KEYPAIR *key, int format, char *fn, HSM *hsm );

#define PKI_KEYPAIR_new_RSA(a) PKI_KEYPAIR_new( PKI_SCHEME_RSA, a );
#define PKI_KEYPAIR_new_DSA(a) PKI_KEYPAIR_new( PKI_SCHEME_DSA, a );
#ifdef ENABLE_ECDSA
#define PKI_KEYPAIR_new_ECDSA(a) PKI_KEYPAIR_new( PKI_SCHEME_ECDSA, a );
#endif

#endif
