/* PKI_X509 I/O management */

#ifndef _LIBPKI_X509_CERT_IO_H
#define _LIBPKI_X509_CERT_IO_H

/* URL and certificates */

PKI_X509_CERT *PKI_X509_CERT_get ( char *url_s );
PKI_X509_CERT *PKI_X509_CERT_get_url ( URL *url );

PKI_X509_CERT_STACK *PKI_X509_CERT_STACK_get ( char *url_s );
PKI_X509_CERT_STACK *PKI_X509_CERT_STACK_get_url ( URL *url );

int PKI_X509_CERT_write ( PKI_X509_CERT *x, int format, char *url_string );
int PKI_X509_CERT_STACK_write (PKI_X509_CERT_STACK *sk, int format, 
							char *url_string);
int PKI_X509_CERT_STACK_write_url (PKI_X509_CERT_STACK *sk, int format, 
								URL *url );
int PKI_X509_CERT_chain_write(PKI_X509_CERT_STACK *sk,int format,char *url_s);
int PKI_X509_CERT_chain_write_url(PKI_X509_CERT_STACK *sk,int format,URL *url);

/* Internal URL certificates operations */

// PKI_X509_CERT *PKI_X509_CERT_get_mem( PKI_MEM *mem );
PKI_X509_CERT_STACK *PKI_X509_CERT_STACK_get_mem( PKI_MEM *mem );

/* 
 * File Operations for Certificates
 */


PKI_X509_CERT_STACK *PKI_X509_CERT_STACK_get_file ( URL *url );
int PKI_X509_CERT_write_file ( PKI_X509_CERT *x, int format, char *file );
int PKI_X509_CERT_STACK_write_file(PKI_X509_CERT_STACK *sk, int format, 
								char *file);

#endif
