/* openca/pkicrypto/url.h */
/*
 * LIBPKI - OpenSource PKI library
 * by Massimiliano Pala (madwolf@openca.org) and OpenCA project
 *
 * Copyright (c) 2001-2007 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */


#ifndef _LIBPKI_URL_HTTP_H
#define _LIBPKI_URL_HTTP_H

#include <libpki/pki_mem.h>
#include <libpki/net/url.h>

#define HTTP_POST			0
#define HTTP_GET			1
#define HTTP_POST_METHOD		"POST"
#define HTTP_GET_METHOD			"GET"

#define LIBPKI_HTTP_BUF_SIZE		8192

/* Function prototypes */
PKI_MEM_STACK *URL_HTTP_get_data ( char *url, ssize_t max_size );
PKI_MEM_STACK *URL_get_data_http_url ( URL *url, ssize_t max_size );

PKI_MEM_STACK * HTTP_post_data ( char *url_s, char *data, ssize_t size, char *content_type );
PKI_MEM_STACK * URL_HTTP_post_data ( URL *url, char *data, ssize_t size, char *content_type );

#endif
