/* OpenCA libpki package
* (c) 2000-2007 by Massimiliano Pala and OpenCA Group
* All Rights Reserved
*
* ===================================================================
* Released under OpenCA LICENSE
*/

#ifndef _LIBPKI_CONF_H
#define _LIBPKI_CONF_H

#define PKI_DEFAULT_CONF_DIR		"file://etc/libpki"
#define PKI_DEFAULT_PROFILE_DIR		"profile.d"
#define PKI_DEFAULT_TOKEN_DIR		"token.d"
#define PKI_DEFAULT_HSM_DIR		"hsm.d"
#define PKI_DEFAULT_STORE_DIR		"store.d"
#define PKI_DEFAULT_CONF_OID_FILE	"objectIdentifiers.xml"

int PKI_CONFIG_free ( PKI_CONFIG * doc );
void PKI_CONFIG_free_void ( void * doc );

PKI_CONFIG * PKI_CONFIG_load(char *urlPath);
PKI_CONFIG_STACK * PKI_CONFIG_load_dir ( char *dir );
PKI_OID * PKI_CONFIG_OID_search ( PKI_CONFIG *doc, char *searchName );

/* Config Options */
char * PKI_CONFIG_get_value ( PKI_CONFIG *doc, char *search );
PKI_STACK * PKI_CONFIG_get_stack_value ( PKI_CONFIG *doc, char *search );

PKI_CONFIG_ELEMENT_STACK * PKI_CONFIG_get_element_stack ( PKI_CONFIG *doc, 
							char *search );

char * PKI_CONFIG_get_element_name (PKI_CONFIG_ELEMENT *e);
char * PKI_CONFIG_get_element_value (PKI_CONFIG_ELEMENT *e);

PKI_CONFIG_ELEMENT * PKI_CONFIG_get_element(PKI_CONFIG *doc, char *search);
PKI_CONFIG_ELEMENT * PKI_CONFIG_get_element_child (PKI_CONFIG_ELEMENT *e);
PKI_CONFIG_ELEMENT * PKI_CONFIG_get_element_next (PKI_CONFIG_ELEMENT *e);
PKI_CONFIG_ELEMENT * PKI_CONFIG_get_element_prev (PKI_CONFIG_ELEMENT *e);

PKI_CONFIG_ELEMENT_STACK * PKI_CONFIG_get_element_children ( 
							PKI_CONFIG_ELEMENT *e);

char * PKI_CONFIG_find ( char *dir, char *name );

#endif
