/* libpki pKey */

#ifndef _LIBPKI_KEYPAIR_HEADER_H
#define _LIBPKI_KEYPAIR_HEADER_H

typedef struct pw_cb_data {
	const void *password;
	const char *prompt_info;
} PW_CB_DATA;

/* Generate a new PKI_KEYPAIR object */
// PKI_KEYPAIR *PKI_KEYPAIR_new( int type, int bits, char *label,
// 						HSM *hsm, PKI_CRED *cred );

/* Free a PKI_KEYPAIR data structure */
// int PKI_KEYPAIR_free( PKI_KEYPAIR *pkey, HSM *hsm );

#define PKI_KEYPAIR_new_RSA(a,l,c,h) PKI_KEYPAIR_new( PKI_SCHEME_RSA,a,l,c,h );
#define PKI_KEYPAIR_new_DSA(a,l,c,h) PKI_KEYPAIR_new( PKI_SCHEME_DSA,a,l,c,h );
#ifdef ENABLE_ECDSA
#define PKI_KEYPAIR_new_ECDSA(a,l,c,h) \
	PKI_KEYPAIR_new(PKI_SCHEME_ECDSA,a,l,c,h);
#endif

#endif
