/*
 * LIBPKI - OpenSource PKI library
 * by Massimiliano Pala (madwolf@openca.org) and OpenCA project
 *
 * Copyright (c) 2001-2007 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */

/* Functions prototypes*/

#ifndef _LIBPKI_PKI_MEM_H
#define _LIBPKI_PKI_MEM_H

typedef struct pki_mem_st {
	char * data;
	long size;
} PKI_MEM;

/* Function prototypes */

void *PKI_Malloc( size_t size );
void PKI_Free( void *ret );

PKI_MEM *PKI_MEM_new ( size_t size );
PKI_MEM *PKI_MEM_new_null ( void );
int PKI_MEM_free ( PKI_MEM *buf );

int PKI_MEM_grow( PKI_MEM *buf, size_t new_size );
int PKI_MEM_add( PKI_MEM *buf, char *data, size_t data_size );
char * PKI_MEM_get( PKI_MEM *buf );
size_t PKI_MEM_get_size( PKI_MEM *buf );

#endif
