/* pki_x509.h */

#ifndef _LIBPKI_X509_CERT_HEADER_H
#define _LIBPKI_X509_CERT_HEADER_H

typedef enum {
	PKI_X509_SERIAL		= 0,
	PKI_X509_SUBJECT,
	PKI_X509_ISSUER,
	PKI_X509_NOTBEFORE,
	PKI_X509_NOTAFTER,
	PKI_X509_ALGORITHM,
	PKI_X509_KEYSIZE,
	PKI_X509_BASIC_CONSTRAINS,
	PKI_X509_EXTENSIONS,
	PKI_X509_KEYPAIR
} PKI_X509_DATA;

/* Memory functions */
int PKI_X509_CERT_free ( PKI_X509_CERT *x );
PKI_X509_CERT * PKI_X509_CERT_new ( PKI_X509_CERT *ca_cert, PKI_KEYPAIR *pkey, 
			PKI_X509_REQ *req, char *subj_s, char *serial,
				PKI_X509_PROFILE *conf, PKI_ALGOR * algor, 
					PKI_CONFIG *oids, HSM *hsm );

/* Print/Get Parsed Data */
void * PKI_X509_CERT_get_data ( PKI_X509_CERT *x, PKI_X509_DATA type );
int PKI_X509_CERT_print_parsed( PKI_X509_CERT *x, 
					PKI_X509_DATA type, int fd );
char * PKI_X509_CERT_get_parsed( PKI_X509_CERT *x, PKI_X509_DATA type );

/* Exts functions */
int PKI_X509_CERT_add_extension ( PKI_X509_CERT *x, PKI_X509_EXTENSION *ext );

/* Fingerprint functions */
PKI_DIGEST *PKI_X509_CERT_fingerprint ( PKI_X509_CERT *x, PKI_DIGEST_ALG *alg );
PKI_DIGEST *PKI_X509_CERT_fingerprint_by_name( PKI_X509_CERT *x, char *alg );

#endif
