/* PKI_X509_CRL object management */

#ifndef _LIBPKI_PKI_X509_CRL_H
#define _LIBPKI_PKI_X509_CRL_H

/* PKI_X509_CRL_ENTRY */
PKI_X509_CRL_ENTRY * PKI_X509_CRL_ENTRY_new ( PKI_X509_CERT *cert, 
					PKI_X509_PROFILE *profile );
PKI_X509_CRL_ENTRY * PKI_X509_CRL_ENTRY_new_serial ( char *serial, 
					PKI_X509_PROFILE *profile );
int PKI_X509_CRL_ENTRY_free ( PKI_X509_CRL_ENTRY *entry );

/* PKI CRL lookup functions */
PKI_X509_CRL_ENTRY * PKI_X509_CRL_lookup_serial( PKI_X509_CRL *x, char *serial );
PKI_X509_CRL_ENTRY * PKI_X509_CRL_lookup_cert ( PKI_X509_CRL *x, PKI_X509_CERT *cert );

/* PKI CRL */
PKI_X509_CRL *PKI_X509_CRL_new ( PKI_KEYPAIR *pkey, PKI_X509_CERT *ca_cert, 
		PKI_X509_CRL_ENTRY_STACK *sk, PKI_X509_PROFILE *profile, HSM *hsm );
PKI_X509_CRL *PKI_X509_CRL_new_tk ( PKI_TOKEN *tk, PKI_X509_CRL_ENTRY_STACK *sk, 
					PKI_X509_PROFILE *profile );
int PKI_X509_CRL_free ( PKI_X509_CRL * x );
int PKI_X509_CRL_add_extension(PKI_X509_CRL *x, PKI_X509_EXTENSION *ext);

void * PKI_X509_CRL_get_data ( PKI_X509_CRL *x, PKI_X509_DATA type );
const char * PKI_X509_CRL_get_parsed( PKI_X509_CRL *x, PKI_X509_DATA type );

#endif
