/* libpki/pki_x509_pkcs7.h */

#ifndef _LIBPKI_X509_PKCS7_H
#define _LIBPKI_X509_PKCS7_H

void PKI_PKCS7_free ( PKI_PKCS7 *p7 );
PKI_PKCS7 *PKI_PKCS7_new ( unsigned char *data, size_t size,
			PKI_KEYPAIR *sign_key, PKI_X509_CERT *enc_cert,
			PKI_DIGEST_ALG *dgst, PKI_ALGOR *enc_alg, int flags );

PKI_PKCS7 *PKI_PKCS7_TK_new ( unsigned char *data, size_t size,
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk,
			PKI_DIGEST_ALG *dgst, PKI_ALGOR *enc_alg, int flags );

PKI_PKCS7 *PKI_PKCS7_new_by_name ( unsigned char *data, size_t size,
			PKI_KEYPAIR *sign_key, PKI_X509_CERT *enc_cert,
			char *dgst_s, char *enc_alg_s, int flags );

PKI_PKCS7 *PKI_PKCS7_TK_new_by_name ( unsigned char *data, size_t size, 
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk,
			char *dgst_s, char *enc_alg_s, int flags );

PKI_PKCS7 *PKI_PKCS7_MEM_new ( PKI_MEM *mem, 
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk, 
			PKI_DIGEST_ALG *dgst, PKI_ALGOR *enc_alg, int flags );

PKI_PKCS7 *PKI_PKCS7_MEM_new_by_name ( PKI_MEM *mem, 
			PKI_TOKEN *sign_tk, PKI_TOKEN *enc_tk, 
			char *dgst_s, char *enc_alg_s, int flags );

#endif


