/* PRQP Implementation
 * (c) 2007 by Massimiliano Pala and OpenCA Group
 * All Rights Reserved
 *
 * This software is released under the GPL2 License included
 * in the archive. You can not remove this copyright notice.
 */
                                                                                
#ifndef _LIBPKI_PRQP_H
#define _LIBPKI_PRQP_H	1
                                                                                
#ifdef  __cplusplus
extern "C" {
#endif

#define PRQP_LIB_CONF_FILE 		"/etc/pki.conf"
#define PRQP_LIB_CONF_ENTRY_LONG 	"queryauthority"
#define PRQP_LIB_CONF_ENTRY_SHORT 	"rqa"

#define PRQP_DEFAULT_PORT		830
#define PRQP_REQ_CONTENT_TYPE		"application/prqp-request"
#define PRQP_RESP_CONTENT_TYPE		"application/prqp-response"

#define SERVICE_TYPE_OCSP_OID             	"1.3.6.1.113733.9.1.1"
#define SERVICE_TYPE_OCSP_OID_STRING     	"OCSP"
#define SERVICE_TYPE_CRL_OID          		"1.3.6.1.113733.9.1.2"
#define SERVICE_TYPE_CRL_OID_STRING		"CRL"
#define SERVICE_TYPE_TIMESTAMPING_OID         	"1.3.6.1.113733.9.1.3"
#define SERVICE_TYPE_TIMESTAMPING_OID_STRING  	"TS"
#define SERVICE_TYPE_DVCS_OID                	"1.3.6.1.113733.9.1.4"
#define SERVICE_TYPE_DVCS_OID_STRING         	"DVCS"
#define SERVICE_TYPE_SCVP_OID                	"1.3.6.1.113733.9.1.5"
#define SERVICE_TYPE_SCVP_OID_STRING         	"SCVP"
#define SERVICE_TYPE_REVOKE_OID                	"1.3.6.1.113733.9.1.6"
#define SERVICE_TYPE_REVOKE_OID_STRING         	"REVOKE"
#define SERVICE_TYPE_SUBSCRIBE_OID          	"1.3.6.1.113733.9.1.7"
#define SERVICE_TYPE_SUBSCRIBE_OID_STRING   	"SUBSCRIBE"

#define PKI_RESOURCE_TYPE_UNKNOWN		0
#define PKI_RESOURCE_TYPE_OCSP			1
#define PKI_RESOURCE_TYPE_CRL			2
#define PKI_RESOURCE_TYPE_TIMESTAMPING		3
#define PKI_RESOURCE_TYPE_DVCS			4
#define PKI_RESOURCE_TYPE_SCVP			5
#define PKI_RESOURCE_TYPE_REVOKE		6
#define PKI_RESOURCE_TYPE_SUBSCRIBE		7

/* PRQP STATUS INFO STRING and VALUES */

#define PRQP_STATUS_STRING_OK			"Ok"
#define PRQP_STATUS_STRING_BAD_REQUEST		"Bad Request"
#define PRQP_STATUS_STRING_CA_NOT_PRESENT	"CA Not Present"
#define PRQP_STATUS_STRING_SYS_FAILURE		"System Failure"
#define PRQP_STATUS_STRING_UNKNOWN		"Unknown"

#define PRQP_STATUS_STRING_NUM			4

typedef enum {
	PRQP_STATUS_UNKNOWN = -1,
	PRQP_STATUS_OK = 0,
	PRQP_STATUS_BAD_REQUEST = 1,
	PRQP_STATUS_CA_NOT_PRESENT = 2,
	PRQP_STATUS_SYS_FAILURE = 3
} PRQP_STATUS;

typedef enum {
	PRQP_DATATYPE_VERSION = 0,
	PRQP_DATATYPE_NONCE,
	PRQP_DATATYPE_PRODUCEDAT,
	PRQP_DATATYPE_NEXTUPDATE,
	PRQP_DATATYPE_SIGNER_CERT,
	PRQP_DATATYPE_OTHER_CERTS,
	PRQP_DATATYPE_SIGNATURE,
	PRQP_DATATYPE_SERVICES,
	PRQP_DATATYPE_PKI_STATUS_INFO_VALUE,
	PRQP_DATATYPE_PKI_STATUS_INFO_STRING,
} PRQP_DATATYPE;

#include <libpki/prqp/prqp_asn1.h>
#include <libpki/prqp/prqp_bio.h>
#include <libpki/prqp/prqp_stack.h>
#include <libpki/prqp/prqp_lib.h>
#include <libpki/prqp/http_client.h>
#include <libpki/prqp/prqp_srv.h>

#ifdef  __cplusplus
}
#endif
#endif

/* end */

