/* PKI Resource Query Protocol Message implementation
 * (c) 2007 by Massimiliano Pala and OpenCA Group
 * All Rights Reserved
 *
 * This software is released under the GPL2 License included
 * in the archive. You can not remove this copyright notice.
 */
                                                                                

#ifndef _LIBPKI_PRQP_BIO_H
#define _LIBPKI_PRQP_BIO_H

#define PEM_STRING_PRQP_REQ "PRQP REQUEST"
#define PEM_STRING_PRQP_RESP "PRQP RESPONSE"

#define PKI_CONTENT_TYPE_PRQP_REQ "application/prqp-request"
#define PKI_CONTENT_TYPE_PRQP_RESP "application/prqp-response"

/* Request BIO */
PRQP_REQ * d2i_PRQP_REQ_bio ( BIO *bp, PRQP_REQ *p );
PRQP_REQ * PEM_read_bio_PRQP_REQ( BIO *bp );
int i2d_PRQP_REQ_bio(BIO *bp, PRQP_REQ *o );
int PEM_write_bio_PRQP_REQ( BIO *bp, PRQP_REQ *o );

PRQP_RESP * d2i_PRQP_RESP_bio( BIO *bp, PRQP_RESP *p );
PRQP_RESP * PEM_read_bio_PRQP_RESP( BIO *bp );
int i2d_PRQP_RESP_bio( BIO *bp, PRQP_RESP *o );
int PEM_write_bio_PRQP_RESP( BIO *bp, PRQP_RESP *o );

/* PRQP REQ get/put interface */
PRQP_REQ *PRQP_REQ_get( char *url_s );
PRQP_REQ *PRQP_REQ_get_url( URL *url );
PRQP_REQ *PRQP_REQ_get_fd( int fd );
PRQP_REQ *PRQP_REQ_get_mem( PKI_MEM *mem );

int PRQP_REQ_put( PRQP_REQ *req, char *url_s, int format );
int PRQP_REQ_put_url( PRQP_REQ *req, URL *url, int format );
int PRQP_REQ_put_mem( PRQP_REQ *req, PKI_MEM *mem, int format );
int PRQP_REQ_put_fp( PRQP_REQ *req, FILE * file, int format );

/* PRQP RESP get/put interface */
PRQP_RESP *PRQP_RESP_get( char *url_s );
PRQP_RESP *PRQP_RESP_get_url( URL *url );
PRQP_RESP *PRQP_RESP_get_fd( int fd );
PRQP_RESP *PRQP_RESP_get_mem( PKI_MEM *mem );

int PRQP_RESP_put(PRQP_RESP *res, char *url_s, int format);
int PRQP_RESP_put_url(PRQP_RESP *res, URL *url, int format);
int PRQP_RESP_put_fp( PRQP_RESP *res, FILE *file, int format );
int PRQP_RESP_put_mem( PRQP_RESP *res, PKI_MEM *mem, int format);

#endif
