/* PRQP Message implementation
 * (c) 2006 by Massimiliano Pala and OpenCA Group
 * All Rights Reserved
 *
 * This software is released under the GPL2 License included
 * in the archive. You can not remove this copyright notice.
 */
                                                                                
#ifndef _LIBPK_PRQP_STACK_H
#define _LIBPK_PRQP_STACK_H
                                                                                
#ifdef  __cplusplus
extern "C" {
#endif

/* Define Stacks for RESOURCE_IDENTIFIER, RESOURCE_RESPONSE_TOKEN and
   ASN1_IA5STRING */

/* RESOURCE_IDENTIFIER stack definitions */
#define sk_RESOURCE_IDENTIFIER_new(st) SKM_sk_new(RESOURCE_IDENTIFIER, (st))
#define sk_RESOURCE_IDENTIFIER_new_null() SKM_sk_new_null(RESOURCE_IDENTIFIER)
#define sk_RESOURCE_IDENTIFIER_free(st) SKM_sk_free(RESOURCE_IDENTIFIER, (st))
#define sk_RESOURCE_IDENTIFIER_num(st) SKM_sk_num(RESOURCE_IDENTIFIER, (st))
#define sk_RESOURCE_IDENTIFIER_value(st, i) SKM_sk_value(RESOURCE_IDENTIFIER, (st), (i))
#define sk_RESOURCE_IDENTIFIER_push(st, val) SKM_sk_push(RESOURCE_IDENTIFIER, (st), (val))
#define sk_RESOURCE_IDENTIFIER_dup(st) SKM_sk_dup(RESOURCE_IDENTIFIER, st)
#define sk_RESOURCE_IDENTIFIER_pop_free(st, free_func) SKM_sk_pop_free(RESOURCE_IDENTIFIER, (st), (free_func))
#define sk_RESOURCE_IDENTIFIER_pop(st) SKM_sk_pop(RESOURCE_IDENTIFIER, (st))

/* RESOURCE_RESPONSE_TOKEN stack definitions */
#define sk_RESOURCE_RESPONSE_TOKEN_new(st) SKM_sk_new(RESOURCE_RESPONSE_TOKEN, (st))
#define sk_RESOURCE_RESPONSE_TOKEN_new_null() SKM_sk_new_null(RESOURCE_RESPONSE_TOKEN)
#define sk_RESOURCE_RESPONSE_TOKEN_free(st) SKM_sk_free(RESOURCE_RESPONSE_TOKEN, (st))
#define sk_RESOURCE_RESPONSE_TOKEN_num(st) SKM_sk_num(RESOURCE_RESPONSE_TOKEN, (st))
#define sk_RESOURCE_RESPONSE_TOKEN_value(st, i) SKM_sk_value(RESOURCE_RESPONSE_TOKEN, (st), (i))
#define sk_RESOURCE_RESPONSE_TOKEN_push(st, val) SKM_sk_push(RESOURCE_RESPONSE_TOKEN, (st), (val))
#define sk_RESOURCE_RESPONSE_TOKEN_dup(st) SKM_sk_dup(RESOURCE_RESPONSE_TOKEN, st)
#define sk_RESOURCE_RESPONSE_TOKEN_pop_free(st, free_func) SKM_sk_pop_free(RESOURCE_RESPONSE_TOKEN, (st), (free_func))
#define sk_RESOURCE_RESPONSE_TOKEN_pop(st) SKM_sk_pop(RESOURCE_RESPONSE_TOKEN, (st))

/* ASN1_IA5STRING stack definitions */
#define sk_ASN1_IA5STRING_new(st) SKM_sk_new(ASN1_IA5STRING, (st))
#define sk_ASN1_IA5STRING_new_null() SKM_sk_new_null(ASN1_IA5STRING)
#define sk_ASN1_IA5STRING_free(st) SKM_sk_free(ASN1_IA5STRING, (st))
#define sk_ASN1_IA5STRING_num(st) SKM_sk_num(ASN1_IA5STRING, (st))
#define sk_ASN1_IA5STRING_value(st, i) SKM_sk_value(ASN1_IA5STRING, (st), (i))
#define sk_ASN1_IA5STRING_push(st, val) SKM_sk_push(ASN1_IA5STRING, (st), (val))
#define sk_ASN1_IA5STRING_dup(st) SKM_sk_dup(ASN1_IA5STRING, st)
#define sk_ASN1_IA5STRING_pop_free(st, free_func) SKM_sk_pop_free(ASN1_IA5STRING, (st), (free_func))
#define sk_ASN1_IA5STRING_pop(st) SKM_sk_pop(ASN1_IA5STRING, (st))


#ifdef  __cplusplus
}
#endif
#endif

/* end */

